## snapd 2.73

=== data/systemd-env/Makefile ===
#
# Copyright (C) 2018 Canonical Ltd
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License version 3 as
# published by the Free Software Foundation.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

USE_CANONICAL_SNAP_MOUNT_DIR ?= true
USE_ALT_SNAP_MOUNT_DIR ?= false

ENVD := /usr/lib/environment.d/

%.conf: %.conf.in
	m4 -P -E \
		-D "USE_CANONICAL_SNAP_MOUNT_DIR=$(USE_CANONICAL_SNAP_MOUNT_DIR)" \
		-D "USE_ALT_SNAP_MOUNT_DIR=$(USE_ALT_SNAP_MOUNT_DIR)" \
		< $< > $@

GENERATED = 990-snapd.conf

all: ${GENERATED}
.PHONY: all

install: ${GENERATED}
	# NOTE: old (e.g. 14.04) GNU coreutils doesn't -D with -t
	install -d -m 0755 ${DESTDIR}/${ENVD}
	install -m 0644 -t ${DESTDIR}/${ENVD} $^
.PHONY: install

clean:
	$(RM) ${GENERATED}
.PHONY: clean

=== debian/changelog ===
snapd (2.73-3) unstable; urgency=medium

  * Revert "debian: remove GOCACHE workaround"

 -- Zygmunt Krynicki <me@zygoon.pl>  Fri, 27 Feb 2026 11:47:12 +0000

snapd (2.73-2) unstable; urgency=medium

  * debian: sync packaging changes from upstream
  * debian: build-depend on golang-golang-x-time-dev
  * debian: stop calling mkversion.sh, generate data by hand
  * debian: remove GOCACHE workaround
  * debian: remove old Ubuntu workarounds
  * debian: work around gopkg.in packaging bug
  * debian: drop the -check.v2 option to dh_auto_test

 -- Zygmunt Krynicki <me@zygoon.pl>  Fri, 27 Feb 2026 11:14:23 +0000

snapd (2.73-1) unstable; urgency=medium

  [ Ernest Lotter ]
  * New upstream release, LP: #2132084
    - FDE: do not save incomplete FDE state when resealing was skipped
    - FDE: warn of inconsistent primary or policy counter
    - Confdb: document confdb in snapctl help messages
    - Confdb: only confdb hooks wait if snaps are disabled
    - Confdb: relax confdb change conflict checks
    - Confdb: remove empty parent when removing last leaf
    - Confdb: support parsing field filters
    - Confdb: wrap confdb write values under "values" key
    - dm-verity for essential snaps: add new naming convention for
      verity files
    - dm-verity for essential snaps: add snap integrity discovery
    - dm-verity for essential snaps: fix verity salt calculation
    - Assertions: add hardware identity assertion
    - Assertions: add integrity stanza in snap resources revisions
    - Assertions: add request message assertion required for remote
      device management
    - Assertions: add response-message assertion for secure remote
      device management
    - Assertions: expose WithStackedBackstore in RODatabase
    - Packaging: cross-distro | install upstream NEWS file into relevant
      snapd package doc directory
    - Packaging: cross-distro | tweak how the blocks injecting
      $SNAP_MOUNT_DIR/bin are generated as required for openSUSE
    - Packaging: remove deprecated snap-gdb-shim and all references now
      that snap run --gdb is unsupported and replaced by --gdbserver
    - Preseed: call systemd-tmpfiles instead handle-writable-paths on
      uc26
    - Preseed: do not remove the /snap dir but rather all its contents
      during reset
    - snap-confine: attach name derived from security tag to BPF maps
      and programs
    - snap-confine: ensure permitted capabilities match expectation
    - snap-confine: fix cached snap-confine profile cleanup to report
      the correct error instead of masking backend setup failures
    - snap-confine: Improve validation of user controlled paths
    - snap-confine: tighten snap cgroup checks to ensure a snap cannot
      start another snap in the same cgroup, preventing incorrect
      device-filter installation
    - core-initrd: add 26.04 ubuntu-core-initramfs package
    - core-initrd: add missing order dependency for setting default
      system files
    - core-initrd: avoid scanning loop and mmc boot partitions as the
      boot disk won't be any of these
    - core-initrd: make cpio a Depends and remove from Build-Depends
    - core-initrd: start plymouth sooner and reload when gadget is
      available
    - Cross-distro: modify syscheck to account for differences in
      openSUSE 16.0+
    - Validation sets: use in-flight validation sets when calling
      'snapctl install' from hook
    - Prompting: enable prompting for the camera interface
    - Prompting: remove polkit authentication when modifying/deleting
      prompting rules
    - LP: #2127189 Prompting: do not record notices for unchanged rules
      on snapd startup
    - AppArmor: add free and pidof to the template
    - AppArmor: adjust interfaces/profiles to cope with coreutils paths
    - Interfaces: add support for compatibility expressions
    - Interfaces: checkbox-support | complete overhaul
    - Interfaces: define vulkan-driver-libs, cuda-driver-libs, egl-
      driver-libs, gbm-driver-libs, opengl-driver-libs, and opengles-
      driver-libs
    - Interfaces: allow snaps on classic access to nvidia graphics
      libraries exported by *-driver-libs interfaces
    - Interfaces: fwupd | broaden access to /boot/efi/EFI
    - Interfaces: gsettings | set dconf-service as profile for
      ca.desrt.dconf.Writer
    - Interfaces: iscsi-initiator, dm-multipath, nvme-control | add new
      interfaces
    - Interfaces: opengl | grant read/write permission to /run/nvidia-
      persistenced/socket
    - interfaces: ros-snapd-support | add access to /v2/changes/
    - Interfaces: system-observe | read access to btrfs/ext4/zfs
      filesystem information
    - Interfaces: system-trace | allow /sys/kernel/tracing/** rw
    - Interfaces: usb-gadget | add support for ffs mounts in attributes
    - Add autocompletion to run command
    - Introduce option for disallowing auto-connection of a specific
      interface
    - Only log errors for user service operations performed as a part of
      snap removal
    - Patch snap names in service requests for parallel installed snaps
    - Simplify traits for eMMC special partitions
    - Strip apparmor_parser from debug symbols shrinking snapd size by
      ~3MB
    - Fix InstallPathMany skipping refresh control
    - Fix waiting for GDB helper to stop before attaching gdbserver
    - Protect the per-snap tmp directory against being reaped by age
    - Prevent disabling base snaps to ensure dependent snaps can be
      removed
    - Modify API endpoint /v2/logs to reject n <= 0 (except for special
      case -1 meaning all)
    - Avoid potential deadlock when task is injected after the change
      was aborted
    - Avoid race between store download stream and cache cleanup
      executing in parallel when invoked by snap download task
    - LP: #1851490 Use "current" instead of revision number for icons
    - LP: #2121853 Add snapctl version command
    - LP: #2127214 Ensure no more than one partition on disk can match a


=== debian/control ===
Source: snapd
Section: devel
Priority: optional
Maintainer: Michael Hudson-Doyle <mwhudson@debian.org>
Uploaders: Zygmunt Krynicki <me@zygoon.pl>, Michael Vogt <mvo@debian.org>
Build-Depends: debhelper (>= 13),
               debhelper-compat (= 13),
               dh-apparmor,
               dh-golang (>=1.7),
               autoconf,
               autoconf-archive,
               automake,
               bash-completion,
               ca-certificates,
               dbus,
               fakeroot,
               gcc-i686-linux-gnu [amd64] <!nocheck>,
               gettext,
               gnupg2,
               golang-dbus-dev,
               golang-github-bmatcuk-doublestar-dev,
               golang-github-coreos-bbolt-dev,
               golang-github-coreos-go-systemd-dev,
               golang-github-gorilla-mux-dev,
               golang-github-jessevdk-go-flags-dev,
               golang-github-juju-ratelimit-dev,
               golang-github-kr-pretty-dev,
               golang-github-mattn-go-runewidth-dev,
               golang-github-mvo5-goconfigparser-dev,
               golang-github-rivo-uniseg-dev,
               golang-github-seccomp-libseccomp-golang-dev,
               golang-go (>=2:1.18),
               golang-golang-x-crypto-dev,
               golang-golang-x-time-dev,
               golang-golang-x-xerrors-dev,
               golang-gopkg-check.v1-dev,
               golang-gopkg-macaroon.v1-dev,
               golang-gopkg-mgo.v2-dev,
               golang-gopkg-retry.v1-dev,
               golang-gopkg-tomb.v2-dev (>= 0.0~git20161208.0.d5d1b58),
               golang-gopkg-tylerb-graceful.v1-dev,
               golang-gopkg-yaml.v2-dev,
               golang-gopkg-yaml.v3-dev,
               grub-common,
               indent,
               libapparmor-dev,
               libblkid-dev,
               libc6-dev-i386-cross [amd64] <!nocheck>,
               libcap-dev,
               libglib2.0-dev,
               liblzo2-dev,
               libseccomp-dev,
               libudev-dev,
               openssh-client,
               pkgconf,
               python3,
               python3-docutils,
               python3-markdown,
               squashfs-tools,
               systemd-dev,
               tzdata,
               udev,
               xfslibs-dev
Standards-Version: 4.7.2
Homepage: https://github.com/snapcore/snapd
Vcs-Browser: https://salsa.debian.org/zyga-guest/snapd
Vcs-Git: https://salsa.debian.org/zyga-guest/snapd.git
XS-Go-Import-Path: github.com/snapcore/snapd

Package: golang-github-snapcore-snapd-dev
Section: golang
Architecture: all
Breaks: golang-github-ubuntu-core-snappy-dev (<< 2.0.6),
        golang-snappy-dev (<< 1.7.3+20160303ubuntu4)
Replaces: golang-github-ubuntu-core-snappy-dev (<< 2.0.6),
          golang-snappy-dev (<< 1.7.3+20160303ubuntu4)
Depends: ${misc:Depends}
Multi-Arch: foreign
Description: Source code of the github.com/snapcore/snapd go module
 This package contains the Go module for all of snapd source code.
 A good chunk of the API is unstable and is not a guaranteed interface.
 The client/ package is more stable and may be used by applications
 looking to integate with the snapd REST API.

Package: snapd
Architecture: any
Depends: adduser,
         apparmor (>= 2.10.95-5),
         ca-certificates,
         default-dbus-session-bus | dbus-session-bus,
         gnupg1 | gnupg,
         kmod,
         libcap2-bin,
         openssh-client,
         squashfs-tools,
         systemd,
         udev,
         ${misc:Depends},
         ${shlibs:Depends}
Replaces: snap-confine (<< 2.23),
          snapd-xdg-open (<= 0.0.0),
          ubuntu-core-launcher (<< 2.22),
          ubuntu-snappy (<< 1.9),
          ubuntu-snappy-cli (<< 1.9)
Breaks: snap (<< 2013-11-29),
        snap-confine (<< 2.23),
        snapd-xdg-open (<= 0.0.0),
        ubuntu-core-launcher (<< 2.22),
        ubuntu-snappy (<< 1.9),
        ubuntu-snappy-cli (<< 1.9),
        ${snapd:Breaks}
Static-Built-Using: ${misc:Static-Built-Using}
Recommends: gnupg
Suggests: zenity | kdialog
Built-Using: ${Built-Using} ${misc:Built-Using}
Description: Daemon and tooling that enable snap packages
 Install, configure, refresh and remove snap packages. Snaps are
 'universal' packages that work across many different Linux systems,
 enabling secure distribution of the latest apps and utilities for
 cloud, servers, desktops and the internet of things.
 .
 Start with 'snap list' to see installed snaps.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
#
# These rules should work for any debian-ish distro that uses systemd
# as init.  That does _not_ include Ubuntu 14.04 ("trusty"); look for
# its own special rule file.
#
# Please keep the diff between that and this relatively small, even if
# it means having suboptimal code; these need to be kept in sync by
# sentient bags of meat.

#export DH_VERBOSE=1
export DH_OPTIONS
export DH_GOPKG := github.com/snapcore/snapd
#export DEB_BUILD_OPTIONS=nocheck
export DH_GOLANG_EXCLUDES=tests
export DH_GOLANG_BUILDPKG = $(strip $(addprefix $(DH_GOPKG)/, \
    cmd/snap \
    cmd/snap-exec \
    cmd/snap-seccomp \
    cmd/snap-update-ns \
    cmd/snapctl \
    cmd/snapd \
    cmd/snapd-apparmor \
    ))
# skip Go generate, all source code should have been committed
export DH_GOLANG_GO_GENERATE=0

export PATH:=${PATH}:${CURDIR}
# GOCACHE is needed by go-1.13+
export GOCACHE:=/tmp/go-build

# this is overridden in the ubuntu/14.04 release branch
SYSTEMD_UNITS_DESTDIR="$(shell pkg-config --variable=systemdsystemunitdir systemd)"

# The go tool does not fully support vendoring with gccgo, but we can
# work around that by constructing the appropriate -I flag by hand.
GCCGO := $(shell go tool dist env > /dev/null 2>&1 && echo no || echo yes)

# Disable -buildmode=pie mode on i386 as can panics in spectacular
# ways (LP: #1711052).
# See also https://forum.snapcraft.io/t/artful-i386-panics/
# Note while the panic is only on artful, that's because artful
# detects it; the issue potentially there on older things.
BUILDFLAGS:=-pkgdir=$(CURDIR)/_build/std
ifneq ($(shell dpkg-architecture -qDEB_HOST_ARCH),i386)
BUILDFLAGS+= -buildmode=pie
endif

GCCGOFLAGS=
ifeq ($(GCCGO),yes)
GOARCH := $(shell go env GOARCH)
GOOS := $(shell go env GOOS)
BUILDFLAGS:=
GCCGOFLAGS=-gccgoflags="-I $(CURDIR)/_build/pkg/gccgo_$(GOOS)_$(GOARCH)/$(DH_GOPKG)/vendor"
export DH_GOLANG_GO_GENERATE=0
# workaround for https://github.com/golang/go/issues/23721
export GOMAXPROCS=2
endif

# check if we need to include the testkeys in the binary
# TAGS are the go build tags for all binaries, SNAP_TAGS are for snap
# build only.
TAGS=nosecboot
SNAP_TAGS=nosecboot nomanagers
ifneq (,$(filter testkeys,$(DEB_BUILD_OPTIONS)))
	TAGS+= withtestkeys
	SNAP_TAGS+= withtestkeys
endif

DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

# /usr/lib/snapd/snap-{update-ns,gdbserver-shim} are always linked
# statically against glibc. Use libc-dev-bin to avoid having to handle the
# different soname (e.g. libc6 vs libc6.1)
BUILT_USING_PACKAGES=libc-dev-bin

# export DEB_BUILD_MAINT_OPTIONS = hardening=+all
# DPKG_EXPORT_BUILDFLAGS = 1
# include /usr/share/dpkg/buildflags.mk

# Currently, we enable confinement for Ubuntu only, not for derivatives,
# because derivatives may have different kernels that don't support all the
# required confinement features and we don't to mislead anyone about the
# security of the system.  Discuss a proper approach to this for downstreams
# if and when they approach us.
ifeq ($(shell dpkg-vendor --query Vendor),Ubuntu)
    # On Ubuntu 16.04 we need to produce a build that can be used on wide
    # variety of systems. As such we prefer static linking over dynamic linking
    # for stability, predicability and easy of deployment. We need to link some
    # things dynamically though: udev has no stable IPC protocol between
    # libudev and udevd so we need to link with it dynamically.
    VENDOR_ARGS=--enable-nvidia-multiarch --enable-static-libcap --enable-static-libapparmor --enable-static-libseccomp --with-host-arch-triplet=$(DEB_HOST_MULTIARCH)
ifeq ($(shell dpkg-architecture -qDEB_HOST_ARCH),amd64)
		VENDOR_ARGS+= --with-host-arch-32bit-triplet=$(shell dpkg-architecture -f -ai386 -qDEB_HOST_MULTIARCH)
endif
    BUILT_USING_PACKAGES+=libcap-dev libapparmor-dev libseccomp-dev
else
ifeq ($(shell dpkg-vendor --query Vendor),Debian)
    VENDOR_ARGS=--enable-nvidia-multiarch
    BUILT_USING_PACKAGES+=libcap-dev
else
    VENDOR_ARGS=--disable-apparmor
endif
endif
BUILT_USING=$(shell dpkg-query -f '$${source:Package} (= $${source:Version}), ' -W $(BUILT_USING_PACKAGES))

%:
	dh $@ --buildsystem=golang --with=golang --builddirectory=_build

override_dh_fixperms:
	dh_fixperms -Xusr/lib/snapd/snap-confine


# The .real profile is a workaround for a bug in dpkg LP: #1673247 that causes
# ubiquity to crash. It allows us to "move" the snap-confine profile from
# snap-confine into snapd in a way that works with old dpkg that is in the live
# CD image.
#
# Because both the usual and the .real profile describe the same binary the
# .real profile takes priority (as it is loaded later).
override_dh_installdeb:
	dh_apparmor --profile-name=usr.lib.snapd.snap-confine.real -psnapd
	dh_installdeb

override_dh_clean:
	dh_clean
	$(MAKE) -C data clean
	# XXX: hacky
	$(MAKE) -C cmd distclean || true

version_from_changelog=$(shell dpkg-parsechangelog --show-field Version)

define snapdtool__version_generated.go
# Generate version files
package snapdtool
func init() {
	Version = "$(version_from_changelog)"
}
endef

define cmd__VERSION
$(version_from_changelog)
endef

define data__info
VERSION=$(version_from_changelog)
SNAPD_APPARMOR_REEXEC=0
SNAPD_ASSERTS_FORMATS='{"account-key":1,"snap-declaration":6,"system-user":2}'
endef

override_dh_auto_build:
	# We used to call mkversion.sh, but since it builds and executes go code
	# from this package it is significantly easier to do by hand.
	$(file >snapdtool/snapdtool__version_generated.go,$(version_generated.go))
	$(file >cmd/VERSION,$(cmd__VERSION))
	$(file >data/info,$(data__INFO))
	# Let's work around a bug in the interaction between dh-goland and
	# golang-gopkg-yaml.v2-dev where /usr/share/gocode/src/gopkg.in/yaml.v2
	# is an empty directory.
	#
	# For details please see: https://lists.debian.org/debian-go/2026/02/msg00126.html
	mkdir -p _build/src/gopkg.in.work
	for p in _build/src/gopkg.in/*; do \
		n=$$(basename "$$p"); \
		if [ "$$n" = "yaml.v2" ]; then \
			ln -sfn ../go.yaml.in/yaml/v2 _build/src/gopkg.in.work/$$n; \
		else \
			ln -sfn "$$(readlink -f "$$p")" _build/src/gopkg.in.work/$$n; \
		fi; \
	done
	rm -rf _build/src/gopkg.in
	mv _build/src/gopkg.in.work _build/src/gopkg.in
	
	# Build golang bits
	mkdir -p _build/src/$(DH_GOPKG)/cmd/snap/test-data
	cp -a cmd/snap/test-data/*.gpg _build/src/$(DH_GOPKG)/cmd/snap/test-data/
	cp -a bootloader/assets/data _build/src/$(DH_GOPKG)/bootloader/assets

	# exclude certain parts that won't be used by debian
	find _build/src/$(DH_GOPKG)/cmd/snap-bootstrap -name "*.go" | xargs rm -f
	find _build/src/$(DH_GOPKG)/cmd/snap-fde-keymgr -name "*.go" | xargs rm -f
	find _build/src/$(DH_GOPKG)/gadget/install -name "*.go" | grep -vE '(params\.go|install_dummy\.go|kernel\.go)'| xargs rm -f
	# XXX: once dh-golang understands go build tags this would not be needed
	find _build/src/$(DH_GOPKG)/secboot/ -name "*.go" | grep -E '(.*_sb(_test)?\.go|.*_tpm(_test)?\.go|secboot_hooks.go|auth_requestor.go|keymgr/)' | xargs rm -f
	mv _build/src/$(DH_GOPKG)/secboot/keys/plainkey.go _build/src/$(DH_GOPKG)/secboot/keys/plainkey_sb.go
	mv _build/src/$(DH_GOPKG)/secboot/keys/plainkey_test.go _build/src/$(DH_GOPKG)/secboot/keys/plainkey_sb_test.go
	find _build/src/$(DH_GOPKG)/secboot/keys/ -name "*.go" | grep -E '(.*_sb(_test)?\.go)' | xargs rm -f
	find _build/src/$(DH_GOPKG)/boot/ -name "*.go" | grep -E '(.*_sb(_test)?\.go)' | xargs rm -f
	# and build, we cannot use modules as packaging on Debian requires us to use
	# dependencies from the distro, and this would require further updates to the
	# go.mod file
	GO111MODULE=off dh_auto_build -- $(BUILDFLAGS) -tags "$(TAGS)" $(GCCGOFLAGS)

	(cd _build/bin && GO111MODULE=off GOPATH=$$(pwd)/.. go build $(BUILDFLAGS) $(GCCGOFLAGS) -tags "$(SNAP_TAGS)" $(DH_GOPKG)/cmd/snap)

	# (static linking on powerpc with cgo is broken)
ifneq ($(shell dpkg-architecture -qDEB_HOST_ARCH),powerpc)

## snapd 2.73%2Bubuntu25.10

=== core-initrd/25.04/debian/changelog ===
ubuntu-core-initramfs (71+2.72+g197.6ffaa0a+25.04) plucky; urgency=medium

  * Remove duplicated dependencies in control file
  * Update to snapd version 2.72+g197.6ffaa0a

 -- Alfonso Sanchez-Beato <alfonso.sanchez-beato@canonical.com>  Tue, 21 Oct 2025 21:38:12 -0400

ubuntu-core-initramfs (71+2.72+g99.77dc6ef-dirty+25.04) plucky; urgency=medium

  * Update to snapd version 2.72+g99.77dc6ef-dirty

 -- Alfonso Sanchez-Beato <alfonso.sanchez-beato@canonical.com>  Tue, 07 Oct 2025 09:19:51 -0400

ubuntu-core-initramfs (71+2.72+g94.e48ddd0-dirty+25.04) plucky; urgency=medium

  * Update to snapd version 2.72+g94.e48ddd0-dirty

 -- Alfonso Sanchez-Beato <alfonso.sanchez-beato@canonical.com>  Tue, 07 Oct 2025 07:57:57 -0400

## snapd 2.73+ubuntu22.04

=== core-initrd/25.10/debian/changelog ===
ubuntu-core-initramfs (72+2.72+g197.6ffaa0a+25.10) questing; urgency=medium

  * Remove duplicated dependencies in control file
  * Update to snapd version 2.72+g197.6ffaa0a

 -- Alfonso Sanchez-Beato <alfonso.sanchez-beato@canonical.com>  Tue, 21 Oct 2025 21:38:28 -0400

ubuntu-core-initramfs (72+2.72+g99.77dc6ef-dirty+25.10) questing; urgency=medium

  * Update to snapd version 2.72+g99.77dc6ef-dirty

 -- Alfonso Sanchez-Beato <alfonso.sanchez-beato@canonical.com>  Tue, 07 Oct 2025 09:20:35 -0400

ubuntu-core-initramfs (72+2.72+g94.e48ddd0-dirty+25.10) questing; urgency=medium

  * Update to snapd version 2.72+g94.e48ddd0-dirty

 -- Alfonso Sanchez-Beato <alfonso.sanchez-beato@canonical.com>  Tue, 07 Oct 2025 07:58:20 -0400

=== core-initrd/26.04/debian/changelog ===
ubuntu-core-initramfs (73+2.72+g197.6ffaa0a+26.04) resolute; urgency=medium

  * Update to snapd version 2.72+g197.6ffaa0a

 -- Alfonso Sanchez-Beato <alfonso.sanchez-beato@canonical.com>  Tue, 21 Oct 2025 21:38:43 -0400

ubuntu-core-initramfs (73+2.72+g149.d9c5491+26.04) resolute; urgency=medium

  * Remove duplicated dependencies in control file

 -- Alfonso Sanchez-Beato <alfonso.sanchez-beato@canonical.com>  Tue, 14 Oct 2025 14:52:51 -0400

## snapd 2.73+ubuntu24.04

=== data/env/Makefile ===
#
# Copyright (C) 2017 Canonical Ltd
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License version 3 as
# published by the Free Software Foundation.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

USE_CANONICAL_SNAP_MOUNT_DIR ?= true
USE_ALT_SNAP_MOUNT_DIR ?= false
ENVD := /etc/profile.d
DATADIR ?= /usr/share

%.sh: %.sh.in
	m4 -P -E \
		-D "USE_CANONICAL_SNAP_MOUNT_DIR=$(USE_CANONICAL_SNAP_MOUNT_DIR)" \
		-D "USE_ALT_SNAP_MOUNT_DIR=$(USE_ALT_SNAP_MOUNT_DIR)" \
		< $< > $@

%.fish: %.fish.in
	m4 -P -E \
		-D "USE_CANONICAL_SNAP_MOUNT_DIR=$(USE_CANONICAL_SNAP_MOUNT_DIR)" \
		-D "USE_ALT_SNAP_MOUNT_DIR=$(USE_ALT_SNAP_MOUNT_DIR)" \
		< $< > $@

GENERATED_SH = snapd.sh
GENERATED_FISH = snapd.fish
GENERATED = ${GENERATED_SH} ${GENERATED_FISH}

all: ${GENERATED}
.PHONY: all

install-sh: ${GENERATED_SH}
	# NOTE: old (e.g. 14.04) GNU coreutils doesn't -D with -t
	install -d -m 0755 ${DESTDIR}/${ENVD}
	install -m 0644 -t ${DESTDIR}/${ENVD} $^

# fish uses a separate directory to store vendor configuration files
install-fish: ${GENERATED_FISH}
	install -d -m 0755 ${DESTDIR}/${DATADIR}/fish/vendor_conf.d
	install -m 0644 -t ${DESTDIR}/${DATADIR}/fish/vendor_conf.d $^

install: install-sh install-fish
.PHONY: install install-sh install-fish

clean:
	$(RM) ${GENERATED}
.PHONY: clean

=== data/systemd/Makefile ===
#
# Copyright (C) 2017 Canonical Ltd
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License version 3 as
# published by the Free Software Foundation.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

SNAPD_ENVIRONMENT_FILE := /etc/environment
BINDIR := /usr/bin
LIBEXECDIR := /usr/lib
SYSTEMDSYSTEMUNITDIR := /lib/systemd/system

# NOTE: the code in wrappers/core18.go assumes that all our service units's
# name start with the "snapd." prefix; units whose filename does not have this
# prefix will not be installed on the host!
SYSTEMD_UNITS_GENERATED := $(wildcard *.in)
# NOTE: sort removes duplicates so this gives us all the units, generated or otherwise
SYSTEMD_UNITS = $(sort $(SYSTEMD_UNITS_GENERATED:.in=) $(wildcard *.service) $(wildcard *.timer) $(wildcard *.socket) $(wildcard *.target))

.PHONY: all
all: $(SYSTEMD_UNITS)

.PHONY: check
check: snapd.run-from-snap snapd.core-fixup.sh
	if command -v shellcheck >/dev/null; then shellcheck $^; fi

.PHONY: install
install: $(SYSTEMD_UNITS)
	# NOTE: old (e.g. 14.04) GNU coreutils doesn't -D with -t
	install -d -m 0755 $(DESTDIR)/$(SYSTEMDSYSTEMUNITDIR)
	install -m 0644 -t $(DESTDIR)/$(SYSTEMDSYSTEMUNITDIR) $^
	install -d -m 0755 $(DESTDIR)/$(LIBEXECDIR)/snapd
	install -m 0755 -t $(DESTDIR)/$(LIBEXECDIR)/snapd snapd.core-fixup.sh
	install -m 0755 -t $(DESTDIR)/$(LIBEXECDIR)/snapd snapd.run-from-snap

.PHONY: clean
clean:
	rm -f $(SYSTEMD_UNITS_GENERATED:.in=)

%: %.in
	cat $< | \
		sed s:@libexecdir@:$(LIBEXECDIR):g | \
		sed s:@SNAPD_ENVIRONMENT_FILE@:$(SNAPD_ENVIRONMENT_FILE):g | \
		sed s:@bindir@:$(BINDIR):g | \
		cat > $@

## snapd 2.73+ubuntu26.04.1

=== tests/lib/libaa-query-peek/Makefile ===
prefix ?= /usr/local
libdir ?= $(prefix)/lib
DESTDIR ?=
CFLAGS = -Wall -Werror
CPPFLAGS ?=

INSTALL ?= install
RM ?= rm

n = libaa-query-peek.so

.PHONY: all clean install uninstall
all: $(n)
clean:
	$(RM) $(n)
install: $(DESTDIR)$(libdir)/$(n)
uninstall:
	$(RM) $(DESTDIR)$(libdir)/$(n)
$(DESTDIR)$(libdir)/$(n): $(n)
	$(INSTALL) -m 755 $< $@
$(n): CFLAGS += -fPIC -shared
$(n): LDLIBS += -ldl
$(n): query.c
	$(CC) $(OUTPUT_OPTION) $(CFLAGS) $(CPPFLAGS) $^ $(LDLIBS)

=== core-initrd/24.04/debian/changelog ===
ubuntu-core-initramfs (69+2.72+g197.6ffaa0a+24.04) noble; urgency=medium

  * Remove duplicated dependencies in control file
  * Update to snapd version 2.72+g197.6ffaa0a

 -- Alfonso Sanchez-Beato <alfonso.sanchez-beato@canonical.com>  Tue, 21 Oct 2025 21:37:53 -0400

ubuntu-core-initramfs (69+2.72+g99.77dc6ef-dirty+24.04) noble; urgency=medium

  * Update to snapd version 2.72+g99.77dc6ef-dirty

 -- Alfonso Sanchez-Beato <alfonso.sanchez-beato@canonical.com>  Tue, 07 Oct 2025 09:18:56 -0400

ubuntu-core-initramfs (69+2.72+g94.e48ddd0-dirty+24.04) noble; urgency=medium

  * Update to snapd version 2.72+g94.e48ddd0-dirty

 -- Alfonso Sanchez-Beato <alfonso.sanchez-beato@canonical.com>  Tue, 07 Oct 2025 07:57:26 -0400

=== core-initrd/25.04/debian/control ===
Source: ubuntu-core-initramfs
Section: utils
Priority: optional
Maintainer: Alfonso Sanchez-Beato <alfonso.sanchez-beato@canonical.com>
Build-Depends: debhelper-compat (= 13), dh-python,
               fakeroot,
               fonts-ubuntu,
               libblkid-dev,
               golang-go (>=2:1.18~) [!powerpc] | golang-1.18 [!powerpc] | golang-1.21,
               pkgconf,
               optee-client-dev [arm64 armhf]
Standards-Version: 4.4.1
Homepage: https://launchpad.net/ubuntu-core-initramfs

Package: ubuntu-core-initramfs
Architecture: amd64 arm64 armhf riscv64
Depends: ${python3:Depends}, ${misc:Depends}, dracut-core (>= 051-1),
         cpio,
         python3:any,
         busybox-initramfs,
         zstd,
         sbsigntool,
         linux-firmware,
         kcapi-tools (>= 1.4.0-1ubuntu3),
         dbus,
         dmsetup,
         dosfstools,
         dpkg-dev,
         e2fsprogs,
         fakeroot,
         fdisk,
         git,
         kmod,
         libblkid1,
         libgcc-s1,
         libkmod2,
         mount,
         plymouth-label-ft,
         plymouth-theme-spinner,
         squashfs-tools,
         systemd,
         systemd-boot-efi,
         systemd-ukify,
         systemd-bootchart,
         systemd-cryptsetup,
         cryptsetup-bin,
         systemd-sysv,
         tar,
         udev,
         util-linux,
         dh-dlopenlibdeps,
         amd64-microcode [amd64],
         intel-microcode [amd64],
         libteec1 [arm64 armhf]
Description: standard embedded initrd
 Standard embedded initrd implementation to be used with Ubuntu Core
 systems. Currently targeting creating BLS Type2 like binaries.

## snapd 2.74+ubuntu26.04

=== core-initrd/24.04/debian/changelog ===
ubuntu-core-initramfs (69+2.73+g132.524048f+24.04) noble; urgency=medium

  * Update to snapd version 2.73+g132.524048f

 -- Alfonso Sanchez-Beato <alfonso.sanchez-beato@canonical.com>  Fri, 09 Jan 2026 08:07:20 -0500

ubuntu-core-initramfs (69+2.73+g76.6a5ca6a+24.04) noble; urgency=medium

  * Update to snapd version 2.73+g76.6a5ca6a

 -- Alfonso Sanchez-Beato <alfonso.sanchez-beato@canonical.com>  Tue, 09 Dec 2025 11:54:48 -0500

ubuntu-core-initramfs (69+2.73+g61.07ddf16+24.04) noble; urgency=medium

  * Update to snapd version 2.73+g61.07ddf16

 -- Alfonso Sanchez-Beato <alfonso.sanchez-beato@canonical.com>  Thu, 04 Dec 2025 13:27:20 +0000

=== core-initrd/25.10/debian/changelog ===
ubuntu-core-initramfs (72+2.73+g132.524048f+25.10ubuntu1) UNRELEASED; urgency=medium

  * Change dependency from libteec1 to libteec2

 -- Alfonso Sanchez-Beato <alfonso.sanchez-beato@canonical.com>  Wed, 14 Jan 2026 17:05:01 -0500

ubuntu-core-initramfs (72+2.73+g132.524048f+25.10) questing; urgency=medium

  * Update to snapd version 2.73+g132.524048f

 -- Alfonso Sanchez-Beato <alfonso.sanchez-beato@canonical.com>  Fri, 09 Jan 2026 08:08:22 -0500

ubuntu-core-initramfs (72+2.73+g76.6a5ca6a+25.10) questing; urgency=medium

  * Update to snapd version 2.73+g76.6a5ca6a

 -- Alfonso Sanchez-Beato <alfonso.sanchez-beato@canonical.com>  Tue, 09 Dec 2025 11:55:39 -0500

ubuntu-core-initramfs (72+2.73+g61.07ddf16+25.10) questing; urgency=medium

  * Update to snapd version 2.73+g61.07ddf16

 -- Alfonso Sanchez-Beato <alfonso.sanchez-beato@canonical.com>  Thu, 04 Dec 2025 13:28:09 +0000

=== core-initrd/26.04/debian/changelog ===
ubuntu-core-initramfs (73+2.73+g132.524048f+26.04ubuntu1) UNRELEASED; urgency=medium

  * Change dependency from libteec1 to libteec2

 -- Alfonso Sanchez-Beato <alfonso.sanchez-beato@canonical.com>  Wed, 14 Jan 2026 17:06:27 -0500

ubuntu-core-initramfs (73+2.73+g132.524048f+26.04) resolute; urgency=medium

  * Update to snapd version 2.73+g132.524048f

 -- Alfonso Sanchez-Beato <alfonso.sanchez-beato@canonical.com>  Fri, 09 Jan 2026 08:08:48 -0500

ubuntu-core-initramfs (73+2.73+g76.6a5ca6a+26.04) resolute; urgency=medium

  * Update to snapd version 2.73+g76.6a5ca6a

 -- Alfonso Sanchez-Beato <alfonso.sanchez-beato@canonical.com>  Tue, 09 Dec 2025 11:56:03 -0500

ubuntu-core-initramfs (73+2.73+g61.07ddf16+26.04) resolute; urgency=medium

  * Update to snapd version 2.73+g61.07ddf16

 -- Alfonso Sanchez-Beato <alfonso.sanchez-beato@canonical.com>  Thu, 04 Dec 2025 13:28:29 +0000

=== debian/changelog ===
snapd (2.74+ubuntu26.04) resolute; urgency=medium

  * New upstream release, LP: #2138629
    - FDE: use new activation API from secboot
    - FDE: use activation API also with non keydata keys
    - FDE: ignore internal recovery key expiration during install
    - FDE: support adding/removing PINs post-installation
    - FDE: support changing PINs post-installation
    - FDE: support adding a recovery key post-installation
    - FDE: provide activation status via new endpoint v2/system-
      info/storage-encrypted
    - FDE: support sealing and resealing using the preinstall check
      result
    - FDE: disable passphrase support during install
    - FDE: add keyboard configuration helpers
    - FDE: lazily inject keyboard layout configuration in kernel cmdline
    - FDE: enable pin tries and limits PIN entry attempts to 3
    - FDE: extend secureboot endpoint to accept DB, KEK, and PK
    - FDE: simplify /v2/system-volumes keyslots handling by allowing
      name-only entries, implicitly expanding to all system containers
    - FDE: support extra non-system key slot names to support agents
      such as Landscape to set dedicated recovery keys
    - FDE: initialize fde state after device state
    - FDE: use device node to find the storage container and keys
    - FDE: provide user visible name for disk based on ID_MODEL
    - FDE: update secboot in snapd with latest additions and fixes
    - core-initrd: add systemd service for setting plymouth keyboard
      layout and X11 keyboard layouts
    - core-initrd: set plymouth cleartext toggle option
    - core-initrd: fix plymouth missing font issue
    - core-initrd: update dependency from libteec1 to libteec2
    - core-initrd: add new dlopened libs
    - LP: #2116949 Preseeding: add support for preseeding of hybrid
      systems via the installer API$
    - Preseeding: check whether a path is a mountpoint before remounting
    - Confdb: support tagging paths as secret in storage schemas
    - Confdb: support filtering on placeholder sub-keys
    - Confdb: support filtering in API and confdbstate
    - Confdb: support field filtering on reads
    - Confdb: support "parameters" stanza and check filters against them
    - Confdb: add support for '--with' contraints
    - Confdb: parsing fixes and error handling improvements
    - Assertions: restrict serials to new format in confdb-control
    - Assertions: add verify signature function
    - Remote device management: modify request-message assertion to
      expose its time constraints for remote device management
    - Remote device management: support polling of store messages
    - Remote device management: add signing of response messages with
      device key
    - Prompting: enable notify protocol v5 and test prompt restoration
      after snapd restart
    - snap: change malformed '--channel=' warning to error
    - snap: add 'snap report-issue' command to get the available contact
      details for the specified snap
    - snap: add 'snap version --verbose' flag to include information on
      snap binaries origin
    - snap: create the XDG_RUNTIME_DIR folder
    - LP: #2068493 snap: add support for 'snap refresh --tracking'
    - snapctl: add '--tracking' flag to 'snapctl refresh'
    - Reexec: include the info filepath in the version compare debug log
    - Reexec: add support for forcing reexec into and older snapd snap
      by setting SNAP_REEXEC=force in the environment
    - snap-confine: correct error message related to snap-confine group
      policy validation
    - snap-confine: ensure we only mount existing directories
    - LP: #2134364 snap-confine: handle potential race when creating
      /tmp/snap-private-tmp when lacking systemd-tmpfiles support
    - snap-confine: filter plus characters from security tags
    - Desktop: use desktop file IDs as desktop IDs
    - Desktop: store the common ID in the desktop file
    - Desktop: allow graphical daemons to show icons in the dock
    - Desktop: change user daemons with desktop plug defined to depend
      on graphical-session.target
    - dm-verity for essential snaps: made change to prerequisite struct
    - Cross-distro: modify SELinux profile to allow connecting to squid
      proxy
    - Cross-distro: add support for migrating snap mount directory
    - Packaging: drop ubuntu-14.04 packaging
    - Packaging: drop ubuntu-{14.04,16.04} transitional binary packages
    - Packaging: remove desktop files and state lock file during snapd
      purge
    - Packaging: fix inhibition hint file being left behind on failed
      unlink-current-snap
    - Disallow timeouts < 1us in systemd units
    - Add snap-store to the user-daemons support overrides
    - Support for SuccessExitStatus= generation for systemd daemon
    - Make standby output more verbose
    - Add prepare-serial-request hook
    - Try to discard snap mount namespaces when no processes are running
      during snap updates
    - Improve handling of snap downloads cache by introducing periodic
      cleanup with more aggressive policy
    - Interfaces: mediatek-accel | create new interface
    - Interfaces: nvidia-video-driver-libs | create new interface
    - Interfaces: *-driver-libs | accept component paths
    - Interfaces: desktop-legacy, unity7 | remove workaround for slash
      filtering in ibus address
    - Interfaces: fwupd | allow writing reboot notification in /run
    - Interfaces: add 'install' coreutil to base AppArmor template
    - Interfaces: u2f-devices | add apparmor permissions to allow the
      use of the libfido2 library in snaps
    - Interfaces: u2f-devices | add support for Thetis security key
    - Interfaces: add AppArmor workaround for mmap MAP_HUGETLB
    - Interfaces: timeserver-control | manage per-link ntp settings via
      systemd-networkd

 -- Ernest Lotter <ernest.lotter@canonical.com>  Tue, 20 Jan 2026 18:54:17 +0200

snapd (2.73+ubuntu26.04.1) resolute; urgency=medium

  * New upstream release, LP: #2132084


=== core-initrd/25.04/debian/control ===
--- 
+++ 
@@ -51,7 +51,7 @@
          dh-dlopenlibdeps,
          amd64-microcode [amd64],
          intel-microcode [amd64],
-         libteec1 [arm64 armhf]
+         libteec2 [arm64 armhf]
 Description: standard embedded initrd
  Standard embedded initrd implementation to be used with Ubuntu Core
  systems. Currently targeting creating BLS Type2 like binaries.

=== core-initrd/26.04/debian/control ===
Source: ubuntu-core-initramfs
Section: utils
Priority: optional
Maintainer: Alfonso Sanchez-Beato <alfonso.sanchez-beato@canonical.com>
Build-Depends: debhelper-compat (= 13), dh-python,
               fakeroot,
               fonts-ubuntu,
               libblkid-dev,
               golang-go (>=2:1.18~) [!powerpc] | golang-1.18 [!powerpc] | golang-1.21,
               pkgconf,
               optee-client-dev [arm64 armhf]
Standards-Version: 4.4.1
Homepage: https://launchpad.net/ubuntu-core-initramfs

Package: ubuntu-core-initramfs
Architecture: amd64 arm64 armhf riscv64
Depends: ${python3:Depends}, ${misc:Depends}, dracut-core (>= 051-1),
         cpio,
         python3:any,
         busybox-initramfs,
         zstd,
         sbsigntool,
         linux-firmware,
         kcapi-tools (>= 1.4.0-1ubuntu3),
         dbus,
         dmsetup,
         dosfstools,
         dpkg-dev,
         e2fsprogs,
         fakeroot,
         fdisk,
         git,
         kmod,
         libblkid1,
         libgcc-s1,
         libkmod2,
         mount,
         plymouth-label-ft,
         plymouth-theme-spinner,
         squashfs-tools,
         systemd,
         systemd-boot-efi,
         systemd-ukify,
         systemd-bootchart,
         systemd-cryptsetup,
         cryptsetup-bin,
         systemd-sysv,
         tar,
         udev,
         util-linux,
         xkb-data,
         dh-dlopenlibdeps,
         amd64-microcode [amd64],
         intel-microcode [amd64],
         libteec2 [arm64 armhf]
Description: standard embedded initrd
 Standard embedded initrd implementation to be used with Ubuntu Core
 systems. Currently targeting creating BLS Type2 like binaries.

=== debian/control ===
Source: snapd
Section: devel
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
Build-Depends: autoconf,
               autoconf-archive,
               automake,
               autotools-dev,
               bash-completion,
               ca-certificates,
               dbus,
               debhelper (>= 9),
               debhelper (>= 9.20160709~) | dh-systemd,
               dh-apparmor,
               dh-autoreconf,
               dh-golang (>=1.7),
               fakeroot,
               flake8,
               gcc-multilib [amd64],
               gettext,
               gnupg2,
               golang-go (>=2:1.18~)  [!powerpc] | golang-1.18 [!powerpc] | golang-1.21,
               grub-common,
               indent,
               init-system-helpers,
               libapparmor-dev,
               libblkid-dev,
               libcap-dev,
               libfuse3-dev (>= 3.10.5-1) | libfuse-dev,
               libglib2.0-dev,
               liblzma-dev,
               liblzo2-dev,
               libseccomp-dev,
               libudev-dev,
               m4,
               openssh-client,
               pkg-config,
               python3,
               python3-bs4,
               python3-docutils,
               python3-markdown,
               python3-pytest,
               squashfs-tools,
               tzdata,
               systemd-dev | systemd (<< 255),
               xfslibs-dev
Standards-Version: 3.9.7
Homepage: https://github.com/snapcore/snapd
Vcs-Browser: https://github.com/snapcore/snapd
Vcs-Git: https://github.com/snapcore/snapd.git

Package: golang-github-snapcore-snapd-dev
Architecture: all
Breaks: golang-github-ubuntu-core-snappy-dev (<< 2.0.6),
        golang-snappy-dev (<< 1.7.3+20160303ubuntu4)
Replaces: golang-github-ubuntu-core-snappy-dev (<< 2.0.6),
          golang-snappy-dev (<< 1.7.3+20160303ubuntu4)
Depends: ${misc:Depends}
Description: snappy development go packages.
 Use these to use the snappy API.

Package: snapd
Architecture: any
Depends: adduser,
         apparmor (>= 2.10.95-0ubuntu2.2),
         ca-certificates,
         fuse3 (>= 3.10.5-1) | fuse,
         libcap2-bin,
         openssh-client,
         squashfs-tools,
         systemd,
         udev,
         ${dbussession:Depends},
         ${misc:Depends},
         ${shlibs:Depends}
Replaces: snap-confine (<< 2.23),
          snapd-xdg-open (<= 0.0.0),
          ubuntu-core-launcher (<< 2.22),
          ubuntu-snappy (<< 1.9),
          ubuntu-snappy-cli (<< 1.9)
Breaks: snap-confine (<< 2.23),
        snapd-xdg-open (<= 0.0.0),
        ubuntu-core-launcher (<< 2.22),
        ubuntu-snappy (<< 1.9),
        ubuntu-snappy-cli (<< 1.9),
        ${snapd:Breaks}
Recommends: gnupg
Suggests: zenity | kdialog
Conflicts: snap (<< 2013-11-29-1ubuntu1)
Built-Using: ${Built-Using} ${misc:Built-Using}
Description: Daemon and tooling that enable snap packages
 Install, configure, refresh and remove snap packages. Snaps are
 'universal' packages that work across many different Linux systems,
 enabling secure distribution of the latest apps and utilities for
 cloud, servers, desktops and the internet of things.
 .
 Start with 'snap list' to see installed snaps.

=== core-initrd/26.04/debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/default.mk

export DH_VERBOSE=1
export DH_OPTIONS

BUILDFLAGS:=
# disable DWARF generation in go linker
BUILDFLAGS+=-ldflags=-w
# Disable -buildmode=pie mode on all our 32bit platforms
# (i386 and armhf). For i386 because of LP: #1711052 and for
# armhf because of LP: #1822738
ifeq ($(shell dpkg-architecture -qDEB_HOST_ARCH_BITS),64)
BUILDFLAGS+=-buildmode=pie
endif

# check if we need to include the testkeys in the binary
ifneq (,$(filter testkeys,$(DEB_BUILD_OPTIONS)))
# if enabled also enable bootloader assets testing and fault injection
_SNAP_TAGS:=nomanagers,withtestkeys,faultinject
else
_SNAP_TAGS:=nomanagers
endif

ifneq (,$(filter arm64 armhf,$(DEB_HOST_ARCH)))
_SNAP_TAGS:=$(_SNAP_TAGS),optee
endif

ifeq (${FIPSBUILD},1)
_SNAP_TAGS:=$(_SNAP_TAGS),goexperiment.opensslcrypto,snapdfips
endif

SNAP_TAGS=-tags "$(_SNAP_TAGS)"

######## targets start here

%:
	dh $@

override_dh_auto_build:
# very ugly test for FIPS variant of a toolchain
# see https://warthogs.atlassian.net/browse/FR-8860
ifeq (${FIPSBUILD},1)
	if ! test -f /usr/lib/go-1.21/src/crypto/internal/backend/openssl_linux.go; then \
		echo "Go 1.21 FIPS toolchain not found"; \
		exit 1; \
	fi
endif
# dh-golang sets GO111MODULE=off if present, fix that
	GOCACHE=/tmp/cache GO111MODULE=on go build -mod=vendor $(BUILDFLAGS) $(SNAP_TAGS) ./cmd/snap-bootstrap

override_dh_auto_install:
	rm -rf debian/tmp
	mkdir debian/tmp
	cp -ar factory/* debian/tmp

# splash functionality
	mkdir -p debian/tmp/usr/share/plymouth/themes/
	cp -a plymouth-theme-ubuntu-core/ubuntu-core \
		debian/tmp/usr/share/plymouth/themes/
	mkdir -p debian/tmp/usr/share/fonts/
	cp /usr/share/fonts/truetype/ubuntu/Ubuntu-R.ttf \
		debian/tmp/usr/share/fonts/Plymouth.ttf
	cp /usr/share/fonts/truetype/ubuntu/UbuntuMono-R.ttf \
		debian/tmp/usr/share/fonts/Plymouth-monospace.ttf

	touch debian/tmp/etc/machine-id

override_dh_clean:
	dh_clean
	rm -f snap-bootstrap

# to avoid dh-golang breaking the build
override_dh_auto_test:

# disable dh_dwz (breaks build for go 1.22)
override_dh_dwz:

override_dh_python3:
	dh_python3 --no-ext-rename

override_dh_fixperms:
	dh_fixperms -Xusr/lib/ubuntu-core-initramfs/main

override_dh_makeshlibs:
	dh_makeshlibs -Xusr/lib/ubuntu-core-initramfs/main

override_dh_shlibdeps:
	dh_shlibdeps -Xusr/lib/ubuntu-core-initramfs/main
